<div *ngIf="!dataLoaded" class="lds-dual-ring"></div>
<div *ngIf="dataLoaded">
  <button mat-button color="accent" (click)="onViewLink()" class="float-right mt-3">View</button>
  <div class="content-wrapper">
    <mat-tab-group [selectedIndex]="selected.value" (selectedIndexChange)="selectedIndexChanged($event)">
      <mat-tab label="Project">
        <form autocomplete="off" (submit)="onSaveProjectInfo(editProjectInfoForm)" #editProjectInfoForm="ngForm">
          <div class="form-group">
            <label for="inputProjectTitle">Project Title</label>
            <input type="text" id="inputProjectTitle" ngModel="{{viewGetProjectName()}}" #inputProjectTitle="ngModel"
              name="inputProjectTitle" class="form-control" placeholder="Project Title" required>
            <div *ngIf="inputProjectTitle.invalid && (inputProjectTitle.touched || editProjectInfoForm.submitted)">
              <div *ngIf="inputProjectTitle.errors.required" class="input-err-text">Project Title can't be empty.</div>
            </div>
          </div>
          <div class="form-group">
            <label for="inputUrl">Url</label>
            <input type="text" id="inputUrl" placeholder="Project Url" ngModel="{{viewGetUrl()}}" #inputUrl="ngModel"
              name="inputUrl" class="form-control">
          </div>
          <div class="form-group">
            <label for="inputDescription">Description</label>
            <input type="text" id="inputDescription" placeholder="Project Description"
              ngModel="{{viewGetRrojectDescription()}}" #inputDescription="ngModel" name="inputDescription"
              class="form-control">
          </div>
          <div class="form-group">
            <label for="selectProjectManagerId">Project manager</label>
            <select name="selectProjectManagerId" id="selectProjectManagerId" class="form-control"
              [(ngModel)]="currentProjectManagerId">
              <option [value]="null"> null </option>
              <option *ngFor="let manager of projectManagers" [value]="manager.userId">
                {{manager.firstName}} {{manager.lastName}}
              </option>
            </select>
          </div>
          <div class="form-group">
            <label for="inputStatus">Status</label>
            <select name="inputStatus" id="inputStatus" class="form-control" [(ngModel)]="currentProjectStatusId">
              <option *ngFor="let status of projectStatusList" [value]="status.projectStatusId">
                {{status.projectStatusName}}
              </option>
            </select>
          </div>
          <div class="row">
            <div class="col">
              <div class="form-group">
                <label for="startDate">Start Date</label>
                <div type="text" id="startDate" name="startDate">{{viewGetStartDate()}}</div>
              </div>
            </div>
            <div class="col">
              <div class="form-group">
                <label for="endDate">End Date</label>
                <div type="text" id="endDate" name="endDate">{{viewGetEndDate()}}</div>
              </div>
            </div>
          </div>
          <button mat-button color="primary" class="w-100 h5 btn-add"> Save </button>
        </form>
      </mat-tab>
      <mat-tab label="Milestones">
        <div class="form-group">
          <label>Milestones</label>
          <div>
            <div class="d-flex justify-content-end mobile-btn-row">
              <button class="btn btn-chart btn-delete" mat-button type="button"
                [disabled]="selectionMilestones.selected.length ? false : true" (click)="onDeleteMilestones()">Delete
                Milestones</button>
              <button type="button" mat-button class="btn btn-copy btn-add" (click)="openDialog(addMilestoneDialog)">Add
                Milestone</button>
            </div>
            <div class="table-container">

              <table mat-table [dataSource]="milestonesInfo" class="mat-elevation-z8 w-100">

                <ng-container matColumnDef="select">
                  <th mat-header-cell *matHeaderCellDef class="checkbox-column">
                  </th>
                  <td mat-cell *matCellDef="let row" class="avatar-cell">
                    <mat-checkbox (click)="$event.stopPropagation()"
                      (change)="$event ? selectionMilestones.toggle(row.id) : null"
                      [checked]="selectionMilestones.isSelected(row.id)" [aria-label]="checkboxLabelMilestones(row.id)">
                    </mat-checkbox>
                  </td>
                </ng-container>

                <ng-container matColumnDef="name">
                  <th mat-header-cell *matHeaderCellDef> Milestone Name </th>
                  <td mat-cell *matCellDef="let element"> {{element.name}} </td>
                </ng-container>

                <ng-container matColumnDef="status">
                  <th mat-header-cell *matHeaderCellDef>Milestone Status </th>
                  <td mat-cell *matCellDef="let element"> {{element.milestoneStatus.milestoneStatusName}} </td>
                </ng-container>

                <ng-container matColumnDef="hours">
                  <th mat-header-cell *matHeaderCellDef> Hours </th>
                  <td mat-cell *matCellDef="let element"> {{element.hours}} </td>
                </ng-container>

                <tr mat-header-row *matHeaderRowDef="displayedMilestonesColumns"></tr>
                <tr mat-row *matRowDef="let row; columns: displayedMilestonesColumns;"></tr>
              </table>
            </div>
          </div>
        </div>
      </mat-tab>
      <mat-tab label="Blockers">
        <div class="form-group">
          <label>Blockers</label>
          <div>
            <div class="d-flex justify-content-end mobile-btn-row">
              <button class="btn btn-chart btn-delete" mat-button type="button"
                [disabled]="selectionBlockers.selected.length ? false : true" (click)="onDeleteTaskBlockers()">Delete
                Blockers</button>
              <button type="button" mat-button class="btn btn-copy btn-add" (click)="openDialog(addBlockerDialog)">Add
                Blocker</button>
            </div>
            <div class="table-container">
              <table mat-table [dataSource]="blockers" class="mat-elevation-z8 w-100">

                <ng-container matColumnDef="select">
                  <th mat-header-cell *matHeaderCellDef class="checkbox-column">
                  </th>
                  <td mat-cell *matCellDef="let row" class="avatar-cell">
                    <mat-checkbox (click)="$event.stopPropagation()"
                      (change)="$event ? selectionBlockers.toggle(row) : null"
                      [checked]="selectionBlockers.isSelected(row)" [aria-label]="checkboxLabelBlockers(row)">
                    </mat-checkbox>
                  </td>
                </ng-container>

                <ng-container matColumnDef="taskName">
                  <th mat-header-cell *matHeaderCellDef> Task Name </th>
                  <td mat-cell *matCellDef="let element"> {{element.taskName}} </td>
                </ng-container>

                <ng-container matColumnDef="taskBlockerName">
                  <th mat-header-cell *matHeaderCellDef> Task Blocker Name </th>
                  <td mat-cell *matCellDef="let element"> {{element.taskBlockerName}} </td>
                </ng-container>

                <tr mat-header-row *matHeaderRowDef="displayedTasksWithBlockersColumns"></tr>
                <tr mat-row *matRowDef="let row; columns: displayedTasksWithBlockersColumns;"></tr>
              </table>
            </div>
          </div>
        </div>
      </mat-tab>

      <mat-tab label="Members">
        <div class="form-group">
          <label>Project Members</label>
          <div class="table-container">
            <div class="d-flex justify-content-end mobile-btn-row">
              <button class="btn btn-chart btn-delete" mat-button type="button"
                [disabled]="selectionMembers.selected.length ? false : true" (click)="onDeleteMembers()">Kick
                Member</button>
              <button type="button" mat-button class="btn btn-copy btn-add"
                (click)="openDialog(addUserToProjectDialog)">Invite
                Member</button>
            </div>
            <div class="table-container">
              <table mat-table [dataSource]="members" class="mat-elevation-z8 w-100">

                <ng-container matColumnDef="select">
                  <th mat-header-cell *matHeaderCellDef class="checkbox-column">
                  </th>
                  <td mat-cell *matCellDef="let row" class="avatar-cell">
                    <mat-checkbox (click)="$event.stopPropagation()"
                      (change)="$event ? selectionMembers.toggle(row.userId) : null"
                      [checked]="selectionNotes.isSelected(row.userId)" [aria-label]="checkboxLabelNotes(row.userId)">
                    </mat-checkbox>
                  </td>
                </ng-container>

                <ng-container matColumnDef="image">
                  <th mat-header-cell *matHeaderCellDef></th>
                  <td mat-cell *matCellDef="let element" class="w-4r">
                    <img class="avatar" src="data:image/PNG;base64,{{element.image}}">
                  </td>
                </ng-container>

                <ng-container matColumnDef="name">
                  <th mat-header-cell *matHeaderCellDef> Name </th>
                  <td mat-cell *matCellDef="let element"> {{element.firstName}} {{element.lastName}}</td>
                </ng-container>

                <ng-container matColumnDef="email">
                  <th mat-header-cell *matHeaderCellDef> Email </th>
                  <td mat-cell *matCellDef="let element"> {{element.email}} </td>
                </ng-container>

                <ng-container matColumnDef="registerDate">
                  <th mat-header-cell *matHeaderCellDef> Register Date </th>
                  <td mat-cell *matCellDef="let element"> {{element.registerDate}} </td>
                </ng-container>

                <ng-container matColumnDef="confirmation">
                  <th mat-header-cell *matHeaderCellDef> Confirmation </th>
                  <td mat-cell *matCellDef="let element">
                    <span *ngIf="element.isConfirmed">Confirmed</span>
                    <span *ngIf="!element.isConfirmed">Unconfirmed</span>
                  </td>
                </ng-container>

                <ng-container matColumnDef="role">
                  <th mat-header-cell *matHeaderCellDef> Roles </th>
                  <td mat-cell *matCellDef="let element; let i = index"> {{element.role.roleName}} </td>
                </ng-container>

                <tr mat-header-row *matHeaderRowDef="displayedMembersColumns"></tr>
                <tr mat-row *matRowDef="let row; columns: displayedMembersColumns;"></tr>
              </table>
            </div>
          </div>
        </div>
      </mat-tab>

      <mat-tab label="Notes">
        <div class="form-group">
          <label for="inputNotes">Notes</label>
          <div class="table-container">
            <div class="d-flex justify-content-end mobile-btn-row">
              <button class="btn btn-chart btn-delete" mat-button type="button"
                [disabled]="selectionNotes.selected.length ? false : true" (click)="onDeleteNote()">Delete
                Notes</button>
              <button type="button" mat-button class="btn btn-copy btn-add" (click)="openDialog(addNoteDialog)">Add
                Note</button>
            </div>
            <div class="table-container">
              <table mat-table [dataSource]="notes" class="mat-elevation-z8 w-100">

                <ng-container matColumnDef="select">
                  <th mat-header-cell *matHeaderCellDef class="checkbox-column">
                  </th>
                  <td mat-cell *matCellDef="let row" class="avatar-cell">
                    <mat-checkbox (click)="$event.stopPropagation()"
                      (change)="$event ? selectionNotes.toggle(row.noteId) : null"
                      [checked]="selectionNotes.isSelected(row.noteId)" [aria-label]="checkboxLabelNotes(row.noteId)">
                    </mat-checkbox>
                  </td>
                </ng-container>

                <ng-container matColumnDef="noteName">
                  <th mat-header-cell *matHeaderCellDef> Note Name </th>
                  <td mat-cell *matCellDef="let element"> {{element.noteName}} </td>
                </ng-container>

                <ng-container matColumnDef="note">
                  <th mat-header-cell *matHeaderCellDef class="w-75"> Note Text </th>
                  <td mat-cell *matCellDef="let element"> {{element.note}} </td>
                </ng-container>

                <tr mat-header-row *matHeaderRowDef="displayedNotesColumns"></tr>
                <tr mat-row *matRowDef="let row; columns: displayedNotesColumns;"></tr>
              </table>
            </div>
          </div>
        </div>
      </mat-tab>
    </mat-tab-group>
  </div>
</div>

<ng-template #addMilestoneDialog>
  <h1 mat-dialog-title>Add new milestone</h1>
  <div mat-dialog-content>
    <form autocomplete="off" (submit)="onAddMilestoneFormSubmit(addMilestone)" #addMilestone="ngForm">

      <div class="form-group">
        <label for="inputMilestoneName">Milestone name</label>
        <input type="text" class="form-control" id="inputMilestoneName" #inputMilestoneName="ngModel"
          name="inputMilestoneName" ngModel required>
        <div *ngIf="inputMilestoneName.invalid && (inputMilestoneName.touched || addMilestone.submitted)">
          <div *ngIf="inputMilestoneName.errors.required" class="input-err-text">Milestone name is required.</div>
        </div>
      </div>

      <div class="form-group">
        <label for="selectMilestoneStatus">Milestone status</label>
        <select name="selectMilestoneStatus" id="selectMilestoneStatus" class="form-control" ngModel
          #selectMilestoneStatus="ngModel" required>
          <option *ngFor="let status of milestoneStatusesList" [value]="status.milestoneStatusId">
            {{status.milestoneStatusName}}
          </option>
        </select>
        <div *ngIf="selectMilestoneStatus.invalid && (selectMilestoneStatus.touched || addMilestone.submitted)">
          <div *ngIf="selectMilestoneStatus.errors.required" class="input-err-text">Milestone Status is required.</div>
        </div>
      </div>

      <button mat-button cdkFocusInitial class="create-button">Save</button>
    </form>
  </div>
</ng-template>

<ng-template #addBlockerDialog>
  <h1 mat-dialog-title>Add new blocker</h1>
  <div mat-dialog-content>
    <form autocomplete="off" (submit)="onSaveTaskBlocker(addBlocker)" #addBlocker="ngForm">

      <div class="form-group">
        <label for="inputSourceTask">Source task</label>
        <select type="text" class="form-control" id="inputSourceTask"
          (change)="generateBlockers(inputSourceTask.control.value)" #inputSourceTask="ngModel" name="inputSourceTask"
          ngModel required>
          <option *ngFor="let task of allTasks" [value]="task.taskId">
            {{task.taskName}}
          </option>
        </select>
        <div *ngIf="inputSourceTask.invalid && (inputSourceTask.touched || addBlocker.submitted)">
          <div *ngIf="inputSourceTask.errors.required" class="input-err-text">Source task is required.</div>
        </div>
      </div>

      <div class="form-group">
        <label for="inputBlocker">Task blocker</label>
        <select type="text" class="form-control" id="inputBlocker" #inputBlocker="ngModel" name="inputBlocker" ngModel
          required>
          <option *ngFor="let task of availableBlockers" [value]="task.taskId">
            {{task.taskName}}
          </option>
        </select>
        <div *ngIf="inputBlocker.invalid && (inputBlocker.touched || addBlocker.submitted)">
          <div *ngIf="inputBlocker.errors.required" class="input-err-text">Task blocker is required.</div>
        </div>
      </div>

      <button mat-button cdkFocusInitial class="create-button">Save</button>
    </form>
  </div>
</ng-template>

<ng-template #addNoteDialog>
  <h1 mat-dialog-title>Add new note</h1>
  <div mat-dialog-content>
    <form autocomplete="off" (submit)="onAddNoteFormSubmit(addNote)" #addNote="ngForm">

      <div class="form-group">
        <label for="inputNoteName">Note name</label>
        <input type="text" class="form-control" id="inputNoteName" #inputNoteName="ngModel" name="inputNoteName" ngModel
          required>
        <div *ngIf="inputNoteName.invalid && (inputNoteName.touched || addNote.submitted)">
          <div *ngIf="inputNoteName.errors.required" class="input-err-text">Note name is required.</div>
        </div>
      </div>

      <div class="form-group">
        <label for="inputNoteText">Note text</label>
        <textarea class="form-control" id="inputNoteText" #inputNoteText="ngModel" name="inputNoteText" ngModel
          required></textarea>
        <div *ngIf="inputNoteText.invalid && (inputNoteText.touched || addNote.submitted)">
          <div *ngIf="inputNoteText.errors.required" class="input-err-text">Note text is required.</div>
        </div>
      </div>

      <button mat-button cdkFocusInitial class="create-button">Save</button>
    </form>
  </div>
</ng-template>

<ng-template #addUserToProjectDialog>
  <h1 mat-dialog-title>User invite dialog</h1>
  <div mat-dialog-content>
    <form autocomplete="off" (submit)="onAddUserToProjectFormSubmit(addUser)" #addUser="ngForm">
      <div class="form-group">
        <label for="inputEmail">Email</label>
        <input type="email" class="form-control" id="inputEmail" #inputEmail="ngModel" name="inputEmail"
          placeholder="you@example.com" [pattern]="emailPattern" ngModel required>
        <div *ngIf="inputEmail.invalid && (inputEmail.touched || addUser.submitted)">
          <div *ngIf="inputEmail.errors.required" class="input-err-text">Email is required.</div>
          <div *ngIf="inputEmail.errors.pattern" class="input-err-text">Email should be like *@*.* format</div>
        </div>
      </div>
      <button mat-button cdkFocusInitial class="create-button">Invite user</button>
    </form>
  </div>
</ng-template>